#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QModelIndex>
#include <QIcon>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
	Q_OBJECT

public:
	MainWindow(QWidget *parent = nullptr);
	~MainWindow();

private:
	Ui::MainWindow *ui;
};

class ReproListModel : public QAbstractListModel {
	Q_OBJECT
public:
	ReproListModel(QMainWindow *window) :
	    _window(window),
	    _icon(":/icon64.png") {
	}

	int rowCount(const QModelIndex &parent = QModelIndex()) const override {
		return 1;
	};

	QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const override {
		if (role == Qt::DisplayRole) {
			return "Hi-dpi repro";
		}
		if (role == Qt::DecorationRole) {
//#define WORKAROUND
#ifdef WORKAROUND
			qreal dpr = _window->devicePixelRatio();
			QPixmap pixmap = _icon.pixmap({ 64, 64 }, qCeil(dpr));
			return pixmap;
#else
			return _icon;
#endif
		}

		return {};
	};

private:
	QMainWindow *_window;
	QIcon _icon;
};

#endif // MAINWINDOW_H
